include masm32rt.inc

include LibSinText.inc
includelib LibSinText.lib


WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD
CenterWnd	proto :DWORD,:DWORD

WND_DATA struct
	hdc			HDC 	?
	time		REAL4	?
WND_DATA ends

.data
	WndSizeFactor_1	REAL4 0.125
	WndSizeFactor_2 REAL4 0.875
	ClassName		db "MainClass32",0
	AppName			db "Main Window",0
.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,OFFSET ClassName
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,OFFSET ClassName,OFFSET AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL rect:RECT
LOCAL t:REAL4
LOCAL tmp:DWORD


	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke DeleteObject,rv(GetWindowLong,hWnd,WND_DATA.hdc)
	.elseif uMsg == WM_CREATE
		invoke CenterWnd,hWnd,rv(GetWindowLong,hWnd,GWL_STYLE)
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		
		fn CreateFont,30,0,0,0,FW_HEAVY,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, FIXED_PITCH,"Arial"
		invoke SelectObject,ebx,eax
		invoke SetBkMode,ebx,TRANSPARENT
		
		; save time of animation start
		invoke SetWindowLong,hWnd,WND_DATA.time,rv(GetTickCount)	
		invoke SetTimer,hWnd,100,50,0

	.elseif uMsg == WM_TIMER
		invoke GetClientRect,hWnd,ADDR rect
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov t,rv(GetWindowLong,hWnd,WND_DATA.time)

		; get current time (since start)
		sub rv(GetTickCount),t
		mov tmp,eax

		; some string
		mov esi,chr$("123456789abcd 1 2 3 4 5 6 234")
		
		;/* clear DC */
		invoke BitBlt,ebx,0,0,rect.right,rect.bottom,ebx,0,0,PATPAINT
		
		fn JmpSine,ebx,JS_XT_WAVE,tmp,20,30,FP4(50.0),200,30,0,esi,0
		fn JmpSine,ebx,JS_XT_WAVE or JS_UPPER_ONLY,tmp,20,120,FP4(50.0),200,30,0,esi,0
		fn JmpSine,ebx,JS_XT_WAVE or JS_LOWER_ONLY,tmp,20,210,FP4(50.0),200,30,0,esi,0
		fn JmpSine,ebx,JS_XT_WAVE or JS_FOLD_UP,tmp,20,300,FP4(50.0),200,30,0,esi,0
		fn JmpSine,ebx,JS_XT_WAVE or JS_FOLD_DOWN,tmp,20,390,FP4(50.0),200,30,0,esi,0
		
		fn JmpSine,ebx,JS_T_WAVE,tmp,400,30,FP4(50.0),200,30,0,esi,0
		mov edx,rect.right
		sub edx,400
		fn JmpSine,ebx,JS_T_WAVE or JS_HORZ_OSCILLATION,tmp,400,120,FP4(50.0),200,30,0,esi,edx
		fn JmpSine,ebx,JS_T_WAVE,tmp,rect.right,210,FP4(-50.0),200,30,0,esi,0
		fn JmpSine,ebx,JS_T_WAVE or JS_HORZ_OSCILLATION or JS_UPPER_ONLY,tmp,400,370,FP4(80.0),100,100,FP4(1.5),"Hello World",500

		invoke SetWindowLong,hWnd,WND_DATA.time,t
		invoke InvalidateRect,hWnd,0,0
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

CenterWnd proc hWnd:DWORD,dwStyle:DWORD
LOCAL cxScreen:DWORD
LOCAL cyScreen:DWORD
LOCAL rect:RECT

	mov cxScreen,rv(GetSystemMetrics,SM_CXSCREEN)
	mov cyScreen,rv(GetSystemMetrics,SM_CYSCREEN)

	finit
	fild cxScreen
	fmul WndSizeFactor_1
	fistp rect.left
	fild cyScreen
	fmul WndSizeFactor_1
	fistp rect.top
	fild cxScreen
	fmul WndSizeFactor_2
	fistp rect.right
	fild cyScreen
	fmul WndSizeFactor_2
	fistp rect.bottom

	invoke AdjustWindowRectEx,ADDR rect,dwStyle,0,0
	mov ecx,rect.right
	sub ecx,rect.left
	mov edx,rect.bottom
	sub edx,rect.top
	invoke MoveWindow,hWnd,rect.left,rect.top,ecx,edx,TRUE

	ret

CenterWnd endp

end main